/*
** 01nov94 08:35 glauber
** main file for uecrypt: uemacs style encryption.
** see file uecrypt.c for more details
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <assert.h>


/* <<<<<<<<<< FILE-WIDE ENTITIES >>>>>>>>>> */

static char * password = NULL;
static char * progname = NULL;


/* <<<<<<<<<< PROTOTYPES >>>>>>>>>> */

static void do_crypt( void );
static void process_commandline( int argc, char * argv[] );
static void set_password( void );
static void syntax( void );



/* <<<<<<<<<< ROCK'N'ROLL >>>>>>>>>> */


int main( int argc, char * argv[] )
{
    /* password from the command line for now */
    /* (should be able to prompt for it) */

    process_commandline( argc, argv );
    set_password();
    do_crypt();

    return (0);
}



static void process_commandline( int argc, char * argv[] )
{
    extern char * optarg;
    int arg;

    progname = strdup( argv[0] );

    while ((arg = getopt( argc, argv, "p:" )) != EOF)
    {
        switch (arg)
        {
            case 'p':
                password = strdup( optarg );
                break;
            case '?':
                syntax();
                exit( 1 );
                break;
            default:
                fprintf( stderr, "Fatal: getopt failure!\n" );
                exit( -1 );
                break;
        }
    }

    if (NULL == password)
    {
        syntax();
        exit( 2 );
    }
}


static void set_password( void )
{
    assert( NULL != password );

    /* encrypt the password and initialize data structures */
    /* details in uecrypt.c */
    ue_crypt( NULL, 0 );
    ue_crypt( password, strlen(password) );
}


static void do_crypt( void )
{
    char line[1024];

    assert( NULL != password );

    while( fgets( line, sizeof(line), stdin ) )
    {
        assert( strlen(line) < sizeof(line) );
        ue_crypt( line, strlen( line ) );
        assert( strlen(line) < sizeof(line) );
        printf( "%s", line );
    }
}


static void syntax( void )
{
    int pos;

    static const char * synt[] =
    {
        "(result is still all printable characters)",
        "This is compatible with the encryption in uemacs and vile,",
        "     NOT with crypt(3).",
        "Encryption and decryption are isomorphic.",
        "Cypher (C) 1986 by Dana L. Hoggatt as \"DLH-POLY-86-B CIPHER\".",
    };

    assert( NULL != progname );

    fprintf( stderr, "%s: encrypt or decrypt a text file\n", progname );
    for (pos = 0; pos < 5; pos++)
    {
        fprintf( stderr, "     %s\n", synt[pos] );
    }
    fprintf( stderr,
            "\n     Syntax: %s -p password <in >out\n\n",
            progname );
}


